diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/mgt-headers.h ns-3.39/src/wifi/model/mgt-headers.h
--- ns-3.38/src/wifi/model/mgt-headers.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/mgt-headers.h	2023-07-05 14:23:48.113428400 -0700
@@ -29,6 +29,7 @@
 #include "ssid.h"
 #include "status-code.h"
 #include "supported-rates.h"
+#include "wifi-mgt-header.h"
 
 #include "ns3/dsss-parameter-set.h"
 #include "ns3/eht-capabilities.h"
@@ -41,41 +42,137 @@
 #include "ns3/mac48-address.h"
 #include "ns3/mu-edca-parameter-set.h"
 #include "ns3/multi-link-element.h"
+#include "ns3/tid-to-link-mapping-element.h"
 #include "ns3/vht-capabilities.h"
 #include "ns3/vht-operation.h"
 
+#include <list>
+
 namespace ns3
 {
 
+class Packet;
+
+/**
+ * Indicate which Information Elements cannot be included in a Per-STA Profile subelement of
+ * a Basic Multi-Link Element (see Sec. 35.3.3.4 of 802.11be D3.1):
+ *
+ * An AP affiliated with an AP MLD shall not include a Timestamp field, a Beacon Interval field,
+ * an AID field, a BSS Max Idle Period element, a Neighbor Report element, a Reduced Neighbor
+ * Report element, a Multiple BSSID element, TIM element, Multiple BSSID-Index element, Multiple
+ * BSSID Configuration element, TID-to-Link Mapping element, Multi-Link Traffic Indication element
+ * or another Multi- Link element in the STA Profile field of the Basic Multi-Link element.
+ *
+ * A non-AP STA affiliated with a non-AP MLD shall not include a Listen Interval field, a Current
+ * AP Address field, an SSID element, BSS Max Idle Period element or another Multi-Link element in
+ * the STA Profile field of the Basic Multi-Link element.
+ */
+
+/** \copydoc CanBeInPerStaProfile */
+template <>
+struct CanBeInPerStaProfile<ReducedNeighborReport> : std::false_type
+{
+};
+
+/** \copydoc CanBeInPerStaProfile */
+template <>
+struct CanBeInPerStaProfile<TidToLinkMapping> : std::false_type
+{
+};
+
+/** \copydoc CanBeInPerStaProfile */
+template <>
+struct CanBeInPerStaProfile<MultiLinkElement> : std::false_type
+{
+};
+
+/** \copydoc CanBeInPerStaProfile */
+template <>
+struct CanBeInPerStaProfile<Ssid> : std::false_type
+{
+};
+
+/// List of Information Elements included in Probe Request frames
+using ProbeRequestElems = std::tuple<Ssid,
+                                     SupportedRates,
+                                     std::optional<ExtendedSupportedRatesIE>,
+                                     std::optional<HtCapabilities>,
+                                     std::optional<ExtendedCapabilities>,
+                                     std::optional<VhtCapabilities>,
+                                     std::optional<HeCapabilities>,
+                                     std::optional<EhtCapabilities>>;
+
+/// List of Information Elements included in Probe Response frames
+using ProbeResponseElems = std::tuple<Ssid,
+                                      SupportedRates,
+                                      std::optional<DsssParameterSet>,
+                                      std::optional<ErpInformation>,
+                                      std::optional<ExtendedSupportedRatesIE>,
+                                      std::optional<EdcaParameterSet>,
+                                      std::optional<HtCapabilities>,
+                                      std::optional<HtOperation>,
+                                      std::optional<ExtendedCapabilities>,
+                                      std::optional<VhtCapabilities>,
+                                      std::optional<VhtOperation>,
+                                      std::optional<ReducedNeighborReport>,
+                                      std::optional<HeCapabilities>,
+                                      std::optional<HeOperation>,
+                                      std::optional<MuEdcaParameterSet>,
+                                      std::optional<MultiLinkElement>,
+                                      std::optional<EhtCapabilities>,
+                                      std::optional<EhtOperation>,
+                                      std::optional<TidToLinkMapping>>;
+
+/// List of Information Elements included in Association Request frames
+using AssocRequestElems = std::tuple<Ssid,
+                                     SupportedRates,
+                                     std::optional<ExtendedSupportedRatesIE>,
+                                     std::optional<HtCapabilities>,
+                                     std::optional<ExtendedCapabilities>,
+                                     std::optional<VhtCapabilities>,
+                                     std::optional<HeCapabilities>,
+                                     std::optional<MultiLinkElement>,
+                                     std::optional<EhtCapabilities>,
+                                     std::optional<TidToLinkMapping>>;
+
+/// List of Information Elements included in Association Response frames
+using AssocResponseElems = std::tuple<SupportedRates,
+                                      std::optional<ExtendedSupportedRatesIE>,
+                                      std::optional<EdcaParameterSet>,
+                                      std::optional<HtCapabilities>,
+                                      std::optional<HtOperation>,
+                                      std::optional<ExtendedCapabilities>,
+                                      std::optional<VhtCapabilities>,
+                                      std::optional<VhtOperation>,
+                                      std::optional<HeCapabilities>,
+                                      std::optional<HeOperation>,
+                                      std::optional<MuEdcaParameterSet>,
+                                      std::optional<MultiLinkElement>,
+                                      std::optional<EhtCapabilities>,
+                                      std::optional<EhtOperation>,
+                                      std::optional<TidToLinkMapping>>;
+
 /**
  * \ingroup wifi
  * Implement the header for management frames of type association request.
  */
-class MgtAssocRequestHeader : public Header
+class MgtAssocRequestHeader
+    : public MgtHeaderInPerStaProfile<MgtAssocRequestHeader, AssocRequestElems>
 {
-  public:
-    MgtAssocRequestHeader();
-    ~MgtAssocRequestHeader() override;
+    friend class WifiMgtHeader<MgtAssocRequestHeader, AssocRequestElems>;
+    friend class MgtHeaderInPerStaProfile<MgtAssocRequestHeader, AssocRequestElems>;
 
-    /**
-     * Set the Service Set Identifier (SSID).
-     *
-     * \param ssid SSID
-     */
-    void SetSsid(const Ssid& ssid);
-
-    /** \copydoc SetSsid */
-    void SetSsid(Ssid&& ssid);
+  public:
+    ~MgtAssocRequestHeader() override = default;
 
     /**
-     * Set the supported rates.
-     *
-     * \param rates the supported rates
+     * Register this type.
+     * \return The TypeId.
      */
-    void SetSupportedRates(const SupportedRates& rates);
+    static TypeId GetTypeId();
 
-    /** \copydoc SetSupportedRates */
-    void SetSupportedRates(SupportedRates&& rates);
+    /** \copydoc Header::GetInstanceTypeId */
+    TypeId GetInstanceTypeId() const override;
 
     /**
      * Set the listen interval.
@@ -83,192 +180,83 @@
      * \param interval the listen interval
      */
     void SetListenInterval(uint16_t interval);
-
-    /**
-     * Set the Capability information.
-     *
-     * \param capabilities Capability information
-     */
-    void SetCapabilities(const CapabilityInformation& capabilities);
-
-    /** \copydoc SetCapabilities */
-    void SetCapabilities(CapabilityInformation&& capabilities);
-
     /**
-     * Set the Extended Capabilities.
+     * Return the listen interval.
      *
-     * \param extendedCapabilities the Extended Capabilities
+     * \return the listen interval
      */
-    void SetExtendedCapabilities(const ExtendedCapabilities& extendedCapabilities);
-
-    /** \copydoc SetExtendedCapabilities */
-    void SetExtendedCapabilities(ExtendedCapabilities&& extendedCapabilities);
-
+    uint16_t GetListenInterval() const;
     /**
-     * Set the HT capabilities.
-     *
-     * \param htCapabilities HT capabilities
+     * \return a reference to the Capability information
      */
-    void SetHtCapabilities(const HtCapabilities& htCapabilities);
-
-    /** \copydoc SetHtCapabilities */
-    void SetHtCapabilities(HtCapabilities&& htCapabilities);
-
+    CapabilityInformation& Capabilities();
     /**
-     * Set the VHT capabilities.
-     *
-     * \param vhtCapabilities VHT capabilities
+     * \return a const reference to the Capability information
      */
-    void SetVhtCapabilities(const VhtCapabilities& vhtCapabilities);
+    const CapabilityInformation& Capabilities() const;
 
-    /** \copydoc SetVhtCapabilities */
-    void SetVhtCapabilities(VhtCapabilities&& vhtCapabilities);
+  protected:
+    /** \copydoc Header::GetSerializedSize */
+    uint32_t GetSerializedSizeImpl() const;
+    /** \copydoc Header::Serialize */
+    void SerializeImpl(Buffer::Iterator start) const;
+    /** \copydoc Header::Deserialize */
+    uint32_t DeserializeImpl(Buffer::Iterator start);
 
     /**
-     * Set the HE capabilities.
-     *
-     * \param heCapabilities HE capabilities
+     * \param frame the frame containing the Multi-Link Element
+     * \return the number of bytes that are needed to serialize this header into a Per-STA Profile
+     *         subelement of the Multi-Link Element
      */
-    void SetHeCapabilities(const HeCapabilities& heCapabilities);
-
-    /** \copydoc SetHeCapabilities */
-    void SetHeCapabilities(HeCapabilities&& heCapabilities);
+    uint32_t GetSerializedSizeInPerStaProfileImpl(const MgtAssocRequestHeader& frame) const;
 
     /**
-     * Set the EHT capabilities.
+     * Serialize this header into a Per-STA Profile subelement of a Multi-Link Element
      *
-     * \param ehtCapabilities EHT capabilities
+     * \param start an iterator which points to where the header should be written
+     * \param frame the frame containing the Multi-Link Element
      */
-    void SetEhtCapabilities(const EhtCapabilities& ehtCapabilities);
-
-    /** \copydoc SetEhtCapabilities */
-    void SetEhtCapabilities(EhtCapabilities&& ehtCapabilities);
+    void SerializeInPerStaProfileImpl(Buffer::Iterator start,
+                                      const MgtAssocRequestHeader& frame) const;
 
     /**
-     * Set the Multi-Link Element information element
-     *
-     * \param multiLinkElement the Multi-Link Element information element
-     */
-    void SetMultiLinkElement(const MultiLinkElement& multiLinkElement);
-
-    /** \copydoc SetMultiLinkElement */
-    void SetMultiLinkElement(MultiLinkElement&& multiLinkElement);
-
-    /**
-     * Return the Capability information.
-     *
-     * \return Capability information
-     */
-    const CapabilityInformation& GetCapabilities() const;
-    /**
-     * Return the extended capabilities, if present.
-     *
-     * \return the extended capabilities, if present
-     */
-    const std::optional<ExtendedCapabilities>& GetExtendedCapabilities() const;
-    /**
-     * Return the HT capabilities, if present.
-     *
-     * \return HT capabilities, if present
-     */
-    const std::optional<HtCapabilities>& GetHtCapabilities() const;
-    /**
-     * Return the VHT capabilities, if present.
-     *
-     * \return VHT capabilities, if present
-     */
-    const std::optional<VhtCapabilities>& GetVhtCapabilities() const;
-    /**
-     * Return the HE capabilities, if present.
-     *
-     * \return HE capabilities, if present
-     */
-    const std::optional<HeCapabilities>& GetHeCapabilities() const;
-    /**
-     * Return the EHT capabilities, if present.
-     *
-     * \return EHT capabilities, if present
-     */
-    const std::optional<EhtCapabilities>& GetEhtCapabilities() const;
-    /**
-     * Return the Service Set Identifier (SSID).
-     *
-     * \return SSID
-     */
-    const Ssid& GetSsid() const;
-    /**
-     * Return the supported rates.
-     *
-     * \return the supported rates
-     */
-    const SupportedRates& GetSupportedRates() const;
-    /**
-     * Return the listen interval.
-     *
-     * \return the listen interval
-     */
-    uint16_t GetListenInterval() const;
-    /**
-     * Return the Multi-Link Element information element, if present.
+     * Deserialize this header from a Per-STA Profile subelement of a Multi-Link Element.
      *
-     * \return the Multi-Link Element information element, if present
+     * \param start an iterator which points to where the header should be read from
+     * \param length the expected number of bytes to read
+     * \param frame the frame containing the Multi-Link Element
+     * \return the number of bytes read
      */
-    const std::optional<MultiLinkElement>& GetMultiLinkElement() const;
-
-    /**
-     * Register this type.
-     * \return The TypeId.
-     */
-    static TypeId GetTypeId();
-
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
+    uint32_t DeserializeFromPerStaProfileImpl(Buffer::Iterator start,
+                                              uint16_t length,
+                                              const MgtAssocRequestHeader& frame);
 
   private:
-    Ssid m_ssid;                                              //!< Service Set ID (SSID)
-    SupportedRates m_rates;                                   //!< List of supported rates
-    CapabilityInformation m_capability;                       //!< Capability information
-    std::optional<ExtendedCapabilities> m_extendedCapability; //!< Extended capabilities
-    std::optional<HtCapabilities> m_htCapability;             //!< HT capabilities
-    std::optional<VhtCapabilities> m_vhtCapability;           //!< VHT capabilities
-    std::optional<HeCapabilities> m_heCapability;             //!< HE capabilities
-    uint16_t m_listenInterval;                                //!< listen interval
-    std::optional<EhtCapabilities> m_ehtCapability;           //!< EHT capabilities
-    std::optional<MultiLinkElement> m_multiLinkElement;       //!< Multi-Link Element
+    CapabilityInformation m_capability; //!< Capability information
+    uint16_t m_listenInterval{0};       //!< listen interval
 };
 
 /**
  * \ingroup wifi
  * Implement the header for management frames of type reassociation request.
  */
-class MgtReassocRequestHeader : public Header
+class MgtReassocRequestHeader
+    : public MgtHeaderInPerStaProfile<MgtReassocRequestHeader, AssocRequestElems>
 {
-  public:
-    MgtReassocRequestHeader();
-    ~MgtReassocRequestHeader() override;
-
-    /**
-     * Set the Service Set Identifier (SSID).
-     *
-     * \param ssid SSID
-     */
-    void SetSsid(const Ssid& ssid);
+    friend class WifiMgtHeader<MgtReassocRequestHeader, AssocRequestElems>;
+    friend class MgtHeaderInPerStaProfile<MgtReassocRequestHeader, AssocRequestElems>;
 
-    /** \copydoc SetSsid */
-    void SetSsid(Ssid&& ssid);
+  public:
+    ~MgtReassocRequestHeader() override = default;
 
     /**
-     * Set the supported rates.
-     *
-     * \param rates the supported rates
+     * Register this type.
+     * \return The TypeId.
      */
-    void SetSupportedRates(const SupportedRates& rates);
+    static TypeId GetTypeId();
 
-    /** \copydoc SetSupportedRates */
-    void SetSupportedRates(SupportedRates&& rates);
+    /** \copydoc Header::GetInstanceTypeId */
+    TypeId GetInstanceTypeId() const override;
 
     /**
      * Set the listen interval.
@@ -276,178 +264,92 @@
      * \param interval the listen interval
      */
     void SetListenInterval(uint16_t interval);
-
-    /**
-     * Set the Capability information.
-     *
-     * \param capabilities Capability information
-     */
-    void SetCapabilities(const CapabilityInformation& capabilities);
-
-    /** \copydoc SetCapabilities */
-    void SetCapabilities(CapabilityInformation&& capabilities);
-
     /**
-     * Set the Extended Capabilities.
+     * Return the listen interval.
      *
-     * \param extendedCapabilities the Extended Capabilities
+     * \return the listen interval
      */
-    void SetExtendedCapabilities(const ExtendedCapabilities& extendedCapabilities);
-
-    /** \copydoc SetExtendedCapabilities */
-    void SetExtendedCapabilities(ExtendedCapabilities&& extendedCapabilities);
-
+    uint16_t GetListenInterval() const;
     /**
-     * Set the HT capabilities.
-     *
-     * \param htCapabilities HT capabilities
+     * \return a reference to the Capability information
      */
-    void SetHtCapabilities(const HtCapabilities& htCapabilities);
-
-    /** \copydoc SetHtCapabilities */
-    void SetHtCapabilities(HtCapabilities&& htCapabilities);
-
+    CapabilityInformation& Capabilities();
     /**
-     * Set the VHT capabilities.
-     *
-     * \param vhtCapabilities VHT capabilities
+     * \return a const reference to the Capability information
      */
-    void SetVhtCapabilities(const VhtCapabilities& vhtCapabilities);
-
-    /** \copydoc SetVhtCapabilities */
-    void SetVhtCapabilities(VhtCapabilities&& vhtCapabilities);
-
+    const CapabilityInformation& Capabilities() const;
     /**
-     * Set the HE capabilities.
+     * Set the address of the current access point.
      *
-     * \param heCapabilities HE capabilities
+     * \param currentApAddr address of the current access point
      */
-    void SetHeCapabilities(const HeCapabilities& heCapabilities);
+    void SetCurrentApAddress(Mac48Address currentApAddr);
 
-    /** \copydoc SetHeCapabilities */
-    void SetHeCapabilities(HeCapabilities&& heCapabilities);
+  protected:
+    /** \copydoc Header::GetSerializedSize */
+    uint32_t GetSerializedSizeImpl() const;
+    /** \copydoc Header::Serialize */
+    void SerializeImpl(Buffer::Iterator start) const;
+    /** \copydoc Header::Deserialize */
+    uint32_t DeserializeImpl(Buffer::Iterator start);
+    /** \copydoc Header::Print */
+    void PrintImpl(std::ostream& os) const;
 
     /**
-     * Set the EHT capabilities.
-     *
-     * \param ehtCapabilities EHT capabilities
+     * \param frame the frame containing the Multi-Link Element
+     * \return the number of bytes that are needed to serialize this header into a Per-STA Profile
+     *         subelement of the Multi-Link Element
      */
-    void SetEhtCapabilities(const EhtCapabilities& ehtCapabilities);
-
-    /** \copydoc SetEhtCapabilities */
-    void SetEhtCapabilities(EhtCapabilities&& ehtCapabilities);
+    uint32_t GetSerializedSizeInPerStaProfileImpl(const MgtReassocRequestHeader& frame) const;
 
     /**
-     * Set the Multi-Link Element information element
+     * Serialize this header into a Per-STA Profile subelement of a Multi-Link Element
      *
-     * \param multiLinkElement the Multi-Link Element information element
+     * \param start an iterator which points to where the header should be written
+     * \param frame the frame containing the Multi-Link Element
      */
-    void SetMultiLinkElement(const MultiLinkElement& multiLinkElement);
+    void SerializeInPerStaProfileImpl(Buffer::Iterator start,
+                                      const MgtReassocRequestHeader& frame) const;
 
-    /** \copydoc SetMultiLinkElement */
-    void SetMultiLinkElement(MultiLinkElement&& multiLinkElement);
-
-    /**
-     * Return the Capability information.
-     *
-     * \return Capability information
-     */
-    const CapabilityInformation& GetCapabilities() const;
-    /**
-     * Return the extended capabilities, if present.
-     *
-     * \return the extended capabilities, if present
-     */
-    const std::optional<ExtendedCapabilities>& GetExtendedCapabilities() const;
-    /**
-     * Return the HT capabilities, if present.
-     *
-     * \return HT capabilities, if present
-     */
-    const std::optional<HtCapabilities>& GetHtCapabilities() const;
-    /**
-     * Return the VHT capabilities, if present.
-     *
-     * \return VHT capabilities, if present
-     */
-    const std::optional<VhtCapabilities>& GetVhtCapabilities() const;
-    /**
-     * Return the HE capabilities, if present.
-     *
-     * \return HE capabilities, if present
-     */
-    const std::optional<HeCapabilities>& GetHeCapabilities() const;
-    /**
-     * Return the EHT capabilities, if present.
-     *
-     * \return EHT capabilities, if present
-     */
-    const std::optional<EhtCapabilities>& GetEhtCapabilities() const;
-    /**
-     * Return the Service Set Identifier (SSID).
-     *
-     * \return SSID
-     */
-    const Ssid& GetSsid() const;
-    /**
-     * Return the supported rates.
-     *
-     * \return the supported rates
-     */
-    const SupportedRates& GetSupportedRates() const;
     /**
-     * Return the Multi-Link Element information element, if present.
+     * Deserialize this header from a Per-STA Profile subelement of a Multi-Link Element.
      *
-     * \return the Multi-Link Element information element, if present
+     * \param start an iterator which points to where the header should be read from
+     * \param length the expected number of bytes to read
+     * \param frame the frame containing the Multi-Link Element
+     * \return the number of bytes read
      */
-    const std::optional<MultiLinkElement>& GetMultiLinkElement() const;
-    /**
-     * Return the listen interval.
-     *
-     * \return the listen interval
-     */
-    uint16_t GetListenInterval() const;
-    /**
-     * Set the address of the current access point.
-     *
-     * \param currentApAddr address of the current access point
-     */
-    void SetCurrentApAddress(Mac48Address currentApAddr);
-
-    /**
-     * Register this type.
-     * \return The TypeId.
-     */
-    static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-    void Print(std::ostream& os) const override;
-    uint32_t GetSerializedSize() const override;
-    void Serialize(Buffer::Iterator start) const override;
-    uint32_t Deserialize(Buffer::Iterator start) override;
+    uint32_t DeserializeFromPerStaProfileImpl(Buffer::Iterator start,
+                                              uint16_t length,
+                                              const MgtReassocRequestHeader& frame);
 
   private:
     Mac48Address m_currentApAddr;       //!< Address of the current access point
-    Ssid m_ssid;                        //!< Service Set ID (SSID)
-    SupportedRates m_rates;             //!< List of supported rates
     CapabilityInformation m_capability; //!< Capability information
-    std::optional<ExtendedCapabilities> m_extendedCapability; //!< Extended capabilities
-    std::optional<HtCapabilities> m_htCapability;             //!< HT capabilities
-    std::optional<VhtCapabilities> m_vhtCapability;           //!< VHT capabilities
-    std::optional<HeCapabilities> m_heCapability;             //!< HE capabilities
-    uint16_t m_listenInterval;                                //!< listen interval
-    std::optional<EhtCapabilities> m_ehtCapability;           //!< EHT capabilities
-    std::optional<MultiLinkElement> m_multiLinkElement;       //!< Multi-Link Element
+    uint16_t m_listenInterval{0};       //!< listen interval
 };
 
 /**
  * \ingroup wifi
  * Implement the header for management frames of type association and reassociation response.
  */
-class MgtAssocResponseHeader : public Header
+class MgtAssocResponseHeader
+    : public MgtHeaderInPerStaProfile<MgtAssocResponseHeader, AssocResponseElems>
 {
+    friend class WifiMgtHeader<MgtAssocResponseHeader, AssocResponseElems>;
+    friend class MgtHeaderInPerStaProfile<MgtAssocResponseHeader, AssocResponseElems>;
+
   public:
-    MgtAssocResponseHeader();
-    ~MgtAssocResponseHeader() override;
+    ~MgtAssocResponseHeader() override = default;
+
+    /**
+     * Register this type.
+     * \return The TypeId.
+     */
+    static TypeId GetTypeId();
+
+    /** \copydoc Header::GetInstanceTypeId */
+    TypeId GetInstanceTypeId() const override;
 
     /**
      * Return the status code.
@@ -456,77 +358,19 @@
      */
     StatusCode GetStatusCode();
     /**
-     * Return the supported rates.
-     *
-     * \return the supported rates
-     */
-    const SupportedRates& GetSupportedRates() const;
-    /**
-     * Return the Capability information.
-     *
-     * \return Capability information
-     */
-    const CapabilityInformation& GetCapabilities() const;
-    /**
-     * Return the extended capabilities, if present.
-     *
-     * \return the extended capabilities, if present
-     */
-    const std::optional<ExtendedCapabilities>& GetExtendedCapabilities() const;
-    /**
-     * Return the HT capabilities, if present.
-     *
-     * \return HT capabilities, if present
-     */
-    const std::optional<HtCapabilities>& GetHtCapabilities() const;
-    /**
-     * Return the HT operation, if present.
-     *
-     * \return HT operation, if present
-     */
-    const std::optional<HtOperation>& GetHtOperation() const;
-    /**
-     * Return the VHT capabilities, if present.
-     *
-     * \return VHT capabilities, if present
-     */
-    const std::optional<VhtCapabilities>& GetVhtCapabilities() const;
-    /**
-     * Return the VHT operation, if present.
-     *
-     * \return VHT operation, if present
-     */
-    const std::optional<VhtOperation>& GetVhtOperation() const;
-    /**
-     * Return the HE capabilities, if present.
-     *
-     * \return HE capabilities, if present
-     */
-    const std::optional<HeCapabilities>& GetHeCapabilities() const;
-    /**
-     * Return the HE operation, if present.
-     *
-     * \return HE operation, if present
-     */
-    const std::optional<HeOperation>& GetHeOperation() const;
-    /**
-     * Return the EHT capabilities, if present.
+     * Set the status code.
      *
-     * \return EHT capabilities, if present
+     * \param code the status code
      */
-    const std::optional<EhtCapabilities>& GetEhtCapabilities() const;
+    void SetStatusCode(StatusCode code);
     /**
-     * Return the EHT operation, if present.
-     *
-     * \return EHT operation, if present
+     * \return a reference to the Capability information
      */
-    const std::optional<EhtOperation>& GetEhtOperation() const;
+    CapabilityInformation& Capabilities();
     /**
-     * Return the Multi-Link Element information element, if present.
-     *
-     * \return the Multi-Link Element information element, if present
+     * \return a const reference to the Capability information
      */
-    const std::optional<MultiLinkElement>& GetMultiLinkElement() const;
+    const CapabilityInformation& Capabilities() const;
     /**
      * Return the association ID.
      *
